de.caff.generics.function

## Interface VarIntOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarIntOperator

  Primitive integer operator with a variable number of arguments.

  Although this basically works for a variable int array via the `apply(int...)` method implementors have to implement the method `apply(IntIndexable)` with a `IntIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default int` | `apply(int... values)` Apply this operator.
    `int` | `apply(IntIndexable values)` Apply this operator.
    `static VarIntOperator` | `fromBinary(java.util.function.IntBinaryOperator binaryOp, int startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default int apply(int... values)

      Apply this operator. This default method forwards execution to `apply(IntIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          int apply(@NotNull
                    IntIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarIntOperator fromBinary(@NotNull
                                                    java.util.function.IntBinaryOperator binaryOp,
                                                    int startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

      >      VarIntOperator maxOp = VarIntOperator.fromBinary(Math::max, Integer.MIN_VALUE);
      >      int max = maxOp.apply(1, -7, -13, 42);

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable int argument operator which applies the given binary operator over and over